
Graphics 320, 200, 16, 2

Global g_FrameTimer = CreateTimer(60)
Global g_CurrentTime
Global g_StartTime_P1
Global g_StartTime_P2
Global g_Time_P1
Global g_Time_P2
Global g_FrameCount_P1
Global g_FrameCount_P2
Global g_LoopCount

Global g_Is_205_Down
Global g_Is_203_Down
Global g_Is_32_Down
Global g_Is_30_Down
Global g_Is_P1_Finished
Global g_Is_P2_Finished

Global g_Playfield = CreateImage(3520, 48)
Global g_AnimImage = LoadAnimImage("gfx/gfx_1.bmp", 48, 48, 0, 7)
Global g_StartSound = LoadSound("sfx/sfx_1.wav")

Type t_Player
	Field m_XPos#
	Field m_XDec#
	Field m_X1_Off#
	Field m_XMax#
	Field m_XMin#
	Field m_AFrame
End Type


DrawPlayfieldImage()

obj1.t_Player = New t_Player
obj2.t_Player = New t_Player


.LOOP

ResetAllVariables()

FrontBuffer()
SetBuffer FrontBuffer()

Cls

DrawEnergieAndPlayfield()

DrawAnimPlayerImages()

Color 255, 255, 255
Text 108,45, "On your mark!"
Delay 3000

Color 0, 0, 0
Rect 50, 47, 200, 12, 1

Color 255, 255, 255
Text 115,45, "Get!...Set!"

g_StartTime_P1 = Rand(1000, 3000)
g_CurrentTime = MilliSecs()

While MilliSecs() < g_CurrentTime + g_StartTime_P1 + g_StartTime_P2
	If KeyHit(30) Then g_StartTime_P2 = g_StartTime_P2 + 250
	If KeyHit(32) Then g_StartTime_P2 = g_StartTime_P2 + 250
	If KeyHit(203) Then g_StartTime_P2 = g_StartTime_P2 + 250
	If KeyHit(205) Then g_StartTime_P2 = g_StartTime_P2 + 250
Wend

PlaySound g_StartSound
Delay 100

Color 0, 0, 0
Rect 50, 47, 200, 12, 1

g_StartTime_P1 = MilliSecs()
g_StartTime_P2 = g_StartTime_P1

While Not KeyHit(1) Or (g_Is_P1_Finished = True And g_Is_P2_Finished = True)

	BackBuffer()
	
	CheckCursorKeys()
			
	CalculateObjectPosition()

	DrawEnergieAndPlayfield()

	DrawAnimPlayerImages()
		
	DrawRunningTime()

	If obj1\m_XPos# >= 3200 Then g_Is_P1_Finished = True
	If obj2\m_XPos# >= 3200 Then g_Is_P2_Finished = True
		
	If g_Is_P1_Finished = False Then g_FrameCount_P1 = g_FrameCount_P1 +1
	If g_Is_P2_Finished = False Then g_FrameCount_P2 = g_FrameCount_P2 +1
	
	g_LoopCount = g_LoopCount + 1

	WaitTimer(g_FrameTimer)
	
	Flip
	
Wend

FrontBuffer()
SetBuffer FrontBuffer()

Color 0, 0, 0
Rect 50, 47, 200, 12, 1
Color 255, 255, 255
Text 90,45, "Play again? (y/n)"

.WAIT
	If KeyHit(49) Then End
	If KeyHit(44) Then Goto LOOP
Goto WAIT

End


Function ResetAllVariables()

	SeedRnd(MilliSecs())

	g_CurrentTime = 0
	g_StartTime_P1 = 0
	g_StartTime_P2 = 0
	g_Time_P1 = 0
	g_Time_P2 = 0
	g_FrameCount_P1 = 0
	g_FrameCount_P2 = 0
	g_LoopCount = 0
	
	g_Is_205_Down = False
	g_Is_203_Down = False
	g_Is_32_Down = False
	g_Is_30_Down = False
	g_Is_P1_Finished = False
	g_Is_P2_Finished = False
	
	obj1.t_Player = First t_Player
	
	obj1\m_XPos# = 0
	obj1\m_XDec# = 0.06
	obj1\m_X1_Off# = 0
	obj1\m_XMax# = 8.0
	obj1\m_XMin# = 1.0
	obj1\m_AFrame = 0
	
	obj2.t_Player = Last t_Player
	
	obj2\m_XPos# = 0
	obj2\m_XDec# = 0.06
	obj2\m_X1_Off# = 0
	obj2\m_XMax# = 8.0
	obj2\m_XMin# = 1.0 
	obj2\m_AFrame = 0

End Function

Function CheckCursorKeys()

	If g_Is_P1_Finished = False

		obj1.t_Player = First t_Player
		
		If KeyDown(32) And g_Is_32_Down = False Then
			obj1\m_X1_Off# = obj1\m_X1_Off# + obj1\m_XDec# * 4
			g_Is_32_Down = True
		End If
		
		If Not KeyDown(32)
			g_Is_32_Down = False
		End If
		
		If KeyDown(30) And g_Is_30_Down = False Then
			obj1\m_X1_Off# = obj1\m_X1_Off# + obj1\m_XDec# * 4
			g_Is_30_Down = True
		End If
		
		If Not KeyDown(30)
			g_Is_30_Down = False
		End If

	End If

	If g_Is_P2_Finished = False
	
		obj2.t_Player = Last t_Player
	
		If KeyDown(205) And g_Is_205_Down = False Then
			obj2\m_X1_Off# = obj2\m_X1_Off# + obj2\m_XDec# * 4
			g_Is_205_Down = True
		End If
		
		If Not KeyDown(205)
			g_Is_205_Down = False
		End If
		
		If KeyDown(203) And g_Is_203_Down = False Then
			obj2\m_X1_Off# = obj2\m_X1_Off# + obj2\m_XDec# * 4
			g_Is_203_Down = True
		End If
		
		If Not KeyDown(203)
			g_Is_203_Down = False
		End If

	End If

End Function

Function CalculateObjectPosition()

	If g_LoopCount >= 7
		obj1.t_Player = First t_Player
		obj1\m_X1_Off# = obj1\m_X1_Off# - obj1\m_XDec# * 6

		obj2.t_Player = Last t_Player
		obj2\m_X1_Off# = obj2\m_X1_Off# - obj2\m_XDec# * 6

		g_LoopCount = 0
	End If 		

	obj1.t_Player = First t_Player

	If obj1\m_X1_Off# <= obj1\m_XMin# Then obj1\m_X1_Off# = obj1\m_XMin#
	If obj1\m_X1_Off# >= obj1\m_XMax# Then obj1\m_X1_Off# = obj1\m_XMax#
	If g_Is_P1_Finished = False Then obj1\m_XPos# = obj1\m_XPos# + obj1\m_X1_Off#


	obj2.t_Player = Last t_Player

	If obj2\m_X1_Off# <= obj2\m_XMin# Then obj2\m_X1_Off# = obj2\m_XMin#
	If obj2\m_X1_Off# >= obj2\m_XMax# Then obj2\m_X1_Off# = obj2\m_XMax#
	If g_Is_P2_Finished = False Then obj2\m_XPos# = obj2\m_XPos# + obj2\m_X1_Off#

End Function

Function DrawAnimPlayerImages()

	Color 0, 0, 0
	Rect 60, 60, 48, 10, 1

	obj1.t_Player = First t_Player

	DrawImageRect g_AnimImage, 60, 60, 0, 0, 48, 48, obj1\m_AFrame

	If g_FrameCount_P1 >= 10 - (obj1\m_X1_Off# * 1.3)
		obj1\m_AFrame = obj1\m_AFRame + 1
		If obj1\m_AFrame > 6 Then obj1\m_AFrame = 0
			
		g_FrameCount_P1 = 0
	End If	


	obj2.t_Player = Last t_Player

	DrawImageRect g_AnimImage, 60, 108, 0, 0, 48, 48, obj2\m_AFrame

	If g_FrameCount_P2 >= 10 - (obj2\m_X1_Off# * 1.3)
		obj2\m_AFrame = obj2\m_AFRame + 1
		If obj2\m_AFrame > 6 Then obj2\m_AFrame = 0
			
		g_FrameCount_P2 = 0
	End If	

End Function

Function DrawPlayfieldImage()

	SetBuffer ImageBuffer(g_Playfield)
	
	Color 100, 100, 100
	Line 0, 22, 3520, 22
	
	For t=0 To 23
		Color t * 2, t * 2, t * 2
		Line 0, t + 23, 3520, t+23
		Color t * 6 + 100, t * 6 + 100, t * 6 + 100
		Plot 90 - t, t + 23
		Plot 92 - t, t + 23
		Plot 410 - t, t + 23
		Plot 730 - t, t + 23
		Plot 1050 - t, t + 23
		Plot 1370 - t, t + 23
		Plot 1690 - t, t + 23
		Plot 2010 - t, t + 23
		Plot 2330 - t, t + 23
		Plot 2650 - t, t + 23
		Plot 2970 - t, t + 23
		Plot 3290 - t, t + 23
		Plot 3294 - t, t + 23
	Next
	
	Color 100, 100, 100
	Text 87, 10, "S"
	Text 82 + 320, 10, "10"
	Text 82 + 640, 10, "20"
	Text 82 + 960, 10, "30"
	Text 82 + 1280, 10, "40"
	Text 82 + 1600, 10, "50"
	Text 82 + 1920, 10, "60"
	Text 82 + 2240, 10, "70"
	Text 82 + 2560, 10, "80"
	Text 82 + 2880, 10, "90"
	Text 90 + 3200, 10, "F"
	Color 255, 255, 255
	Line 0, 47, 3520, 47
	
	SetBuffer BackBuffer()

End Function

Function DrawEnergieAndPlayfield()

	Color 0, 0, 0
	Rect 0, 20, 120, 10, 1
	Rect 200, 20, 120, 10, 1

	obj1.t_Player = First t_Player

	Color 255 - obj1\m_X1_Off# * 20, 50 + obj1\m_X1_Off# * 20, 0
	Rect 0, 20, obj1\m_X1_Off# * 15, 10, 1
	DrawBlockRect g_Playfield, 0, 68, obj1\m_XPos#, 0, 320, 48
	
	
	obj2.t_Player = Last t_Player

	Color 255 - obj2\m_X1_Off# * 20, 50 + obj2\m_X1_Off# * 20, 0
	Rect 200, 20, obj2\m_X1_Off# * 15, 10, 1
	DrawBlockRect g_Playfield, 0, 116, obj2\m_XPos#, 0, 320, 48	
	
	Color 255, 255, 255
	Rect 0, 20, 120, 10, 0
	Rect 200, 20, 120, 10, 0

End Function

Function DrawRunningTime()

	g_CurrentTime = MilliSecs()
	If g_Is_P1_Finished = False Then g_Time_P1 = g_CurrentTime - g_StartTime_P1
	If g_Is_P2_Finished = False Then g_Time_P2 = g_CurrentTime - g_StartTime_P2
	
	Color 0, 0, 0
	Rect 22, 30, 80, 10
	Rect 222, 30, 80, 10
		
	Color 255, 255, 255
	If 	(g_Time_P1 / 1000) < 10
		Text 22, 29, "00:0" + (g_Time_P1 / 1000) + ":" + Right$(Str g_Time_P1, 3)
		Text 222, 29, "00:0" + (g_Time_P2 / 1000) + ":" + Right$(Str g_Time_P2, 3)
	Else
		Text 22, 29, "00:" + (g_Time_P1 / 1000) + ":" + Right$(Str g_Time_P1, 3)
		Text 222, 29, "00:" + (g_Time_P2 / 1000) + ":" + Right$(Str g_Time_P2, 3)
	End If
	
	Color 50, 50, 50
	Text 30, 185, "(c) 2008 E. Neubeck for BCC #18"
	
End Function